# Generated by Django 3.2.7 on 2021-10-04 14:27

from django.conf import settings
import django.contrib.postgres.indexes
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import django.db.models.functions.text
import simple_history.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('core', '0001_create_extensions'),
    ]

    operations = [
        migrations.CreateModel(
            name='Inventory',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(db_index=True, max_length=50)),
                ('status', models.CharField(choices=[('OPEN', 'Open'), ('CLOSED', 'Closed'), ('ARCHIVED', 'Archived')], default='OPEN', max_length=8)),
                ('description', models.TextField(blank=True, default='', max_length=250)),
                ('creation_date', models.DateTimeField(auto_now_add=True)),
                ('last_update_date', models.DateTimeField(auto_now=True)),
                ('expiry_date', models.DateTimeField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='InventoryList',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(db_index=True, max_length=50)),
                ('description', models.TextField(blank=True, default='', max_length=250)),
                ('status', models.CharField(choices=[('OPEN', 'Open'), ('CLOSED', 'Closed'), ('ARCHIVED', 'Archived')], default='OPEN', max_length=8)),
                ('creation_date', models.DateTimeField(auto_now_add=True)),
                ('last_update_date', models.DateTimeField(auto_now=True)),
                ('expiry_date', models.DateTimeField(blank=True, default=None, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='ScientificEntry',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField(db_index=True)),
                ('source', models.CharField(blank=True, default='', max_length=100)),
                ('score', models.IntegerField(blank=True, default=1)),
                ('comment', models.CharField(blank=True, default='', max_length=150)),
            ],
        ),
        migrations.CreateModel(
            name='Taxon',
            fields=[
                ('id', models.IntegerField(primary_key=True, serialize=False)),
                ('rank', models.CharField(choices=[('ROOT', 'Root'), ('SUPERKINGDOM', 'Superkingdom'), ('KINGDOM', 'Kingdom'), ('SUBKINGDOM', 'Subkingdom'), ('SUPERPHYLUM', 'Superphylum'), ('PHYLUM', 'Phylum'), ('SUBPHYLUM', 'Subphylum'), ('SUPERCLASS', 'Superclass'), ('CLASS', 'Class'), ('SUBCLASS', 'Subclass'), ('INFRACLASS', 'Infraclass'), ('COHORT', 'Cohort'), ('SUBCOHORT', 'Subcohort'), ('SUPERORDER', 'Superorder'), ('ORDER', 'Order'), ('SUBORDER', 'Suborder'), ('INFRAORDER', 'Infraorder'), ('SUPERFAMILY', 'Superfamily'), ('FAMILY', 'Family'), ('SUBFAMILY', 'Subfamily'), ('TRIBE', 'Tribe'), ('SUBTRIBE', 'Subtribe'), ('GENUS', 'Genus'), ('SUBGENUS', 'Subgenus'), ('SECTION', 'Section'), ('SUBSECTION', 'Subsection'), ('SERIES', 'Series'), ('SPECIES', 'Species'), ('SUBSPECIES', 'Subspecies'), ('VARIETAS', 'Varietas'), ('SUBVARIETY', 'Subvariety'), ('FORMA', 'Forma'), ('FORMASPECIALIS', 'Formaspecialis'), ('CLADE', 'Clade'), ('STRAIN', 'Strain'), ('SEROGROUP', 'Serogroup'), ('SEROTYPE', 'Serotype'), ('BIOTYPE', 'Biotype'), ('GENOTYPE', 'Genotype'), ('SPECIESGROUP', 'Speciesgroup'), ('SPECIESSUBGROUP', 'Speciessubgroup'), ('ISOLATE', 'Isolate'), ('PARVORDER', 'Parvorder'), ('MORPH', 'Morph'), ('PATHOGROUP', 'Pathogroup'), ('UNDEFINED', 'Undefined')], default='UNDEFINED', max_length=21)),
                ('main_scientific_entry', models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='taxon+', to='core.scientificentry')),
                ('parent', models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to='core.taxon')),
            ],
        ),
        migrations.CreateModel(
            name='Identifiers',
            fields=[
                ('taxon', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, primary_key=True, related_name='identifiers', serialize=False, to='core.taxon')),
                ('gbif', models.CharField(blank=True, default='', max_length=10, validators=[django.core.validators.RegexValidator(message="L'identifiant gbif doit être un nombre entier.", regex='^[0-9]*$')])),
                ('ncbi', models.CharField(blank=True, default='', max_length=10, validators=[django.core.validators.RegexValidator(message="L'identifiant ncbi doit être un nombre entier.", regex='^[0-9]*$')])),
                ('inaturalist', models.CharField(blank=True, default='', max_length=10, validators=[django.core.validators.RegexValidator(message="L'identifiant inaturalist doit être un nombre entier.", regex='^[0-9]*$')])),
                ('iucn', models.CharField(blank=True, default='', max_length=42, validators=[django.core.validators.RegexValidator(message="L'identifiant iucn doit être composé de deux nombres séparés par un '/'.", regex='^[0-9]+/[0-9]+$')])),
                ('wikidata', models.CharField(blank=True, default='', max_length=21, validators=[django.core.validators.RegexValidator(message="L'identifiant wikidata doit commencer par la lettre Q suivi d'un nombre.", regex='^Q[0-9]+$')])),
                ('wikispecies', models.CharField(blank=True, default='', max_length=50)),
                ('wikipedia', models.CharField(blank=True, default='', max_length=50)),
                ('taxref', models.CharField(blank=True, default='', max_length=10, validators=[django.core.validators.RegexValidator(message="L'identifiant taxref doit être un nombre entier.", regex='^[0-9]*$')])),
            ],
        ),
        migrations.CreateModel(
            name='VernacularEntry',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField(db_index=True, validators=[django.core.validators.RegexValidator(message='Le nom vernaculaire ne peut contenir que des caractères français.', regex='^[a-zA-Z àâäèéêëîïôœùûüÿçÀÂÄÈÉÊËÎÏÔŒÙÛÜŸÇ"]*$')])),
                ('language', models.CharField(blank=True, choices=[('FR', 'Fr')], default='FR', max_length=2)),
                ('locality', models.CharField(blank=True, default='', max_length=100)),
                ('source', models.CharField(blank=True, default='', max_length=100)),
                ('score', models.IntegerField(blank=True, default=1)),
                ('gender', models.CharField(blank=True, choices=[('ALL', 'All'), ('FEMALE', 'Female'), ('MALE', 'Male'), ('UNDEFINED', 'Undefined')], default='ALL', max_length=10)),
                ('lifestage', models.CharField(blank=True, choices=[('ALL', 'All'), ('ZYGOTE', 'Zygote'), ('EMBRYO', 'Embryo'), ('LARVA', 'Larva'), ('JUVENILE', 'Juvenile'), ('ADULT', 'Adult'), ('SPOROPHYTE', 'Sporophyte'), ('SPORE', 'Spore'), ('GAMETOPHYTE', 'Gametophyte'), ('GAMETE', 'Gamete'), ('PUPA', 'Pupa'), ('UNDEFINED', 'Undefined')], default='ALL', max_length=11)),
                ('comment', models.CharField(blank=True, default='', max_length=150)),
                ('taxon', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='VernacularEntry', to='core.taxon')),
            ],
        ),
        migrations.CreateModel(
            name='Uri',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('identifier', models.CharField(max_length=100, unique=True, validators=[django.core.validators.RegexValidator(message='L"identifier doit être composés de lettres, chiffres ou -', regex='^[a-zA-Z-0-9]+$'), django.core.validators.RegexValidator(message="L'identifier ne peut pas contenir que des chiffres", regex='(?!^\\d+$)^.+$'), django.core.validators.MinLengthValidator(limit_value=3)])),
                ('creation_date', models.DateTimeField(auto_now_add=True)),
                ('last_update_date', models.DateTimeField(auto_now=True)),
                ('inventory_list', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, related_name='uri', to='core.inventorylist')),
            ],
        ),
        migrations.AddField(
            model_name='scientificentry',
            name='taxon',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='ScientificEntry', to='core.taxon'),
        ),
        migrations.CreateModel(
            name='Plot',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(db_index=True, max_length=50)),
                ('description', models.TextField(blank=True, default='', max_length=250)),
                ('creation_date', models.DateTimeField(auto_now_add=True)),
                ('last_update_date', models.DateTimeField(auto_now=True)),
                ('inventory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.inventory')),
            ],
        ),
        migrations.CreateModel(
            name='Observation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('comment', models.TextField(blank=True, default='', max_length=250)),
                ('observator_nickname', models.CharField(blank=True, default='', max_length=30)),
                ('quantification_number', models.PositiveIntegerField(blank=True, null=True)),
                ('quantification_percentage', models.DecimalField(blank=True, decimal_places=3, max_digits=4, null=True, validators=[django.core.validators.MinValueValidator(0), django.core.validators.MaxValueValidator(1)])),
                ('alive', models.CharField(choices=[('YES', 'Yes'), ('NO', 'No'), ('UNDEFINED', 'Undefined')], default='UNDEFINED', max_length=9)),
                ('spontaneous', models.CharField(choices=[('YES', 'Yes'), ('NO', 'No'), ('UNDEFINED', 'Undefined')], default='UNDEFINED', max_length=9)),
                ('gender', models.CharField(choices=[('ALL', 'All'), ('FEMALE', 'Female'), ('MALE', 'Male'), ('UNDEFINED', 'Undefined')], default='UNDEFINED', max_length=9)),
                ('lifestage', models.CharField(choices=[('ALL', 'All'), ('ZYGOTE', 'Zygote'), ('EMBRYO', 'Embryo'), ('LARVA', 'Larva'), ('JUVENILE', 'Juvenile'), ('ADULT', 'Adult'), ('SPOROPHYTE', 'Sporophyte'), ('SPORE', 'Spore'), ('GAMETOPHYTE', 'Gametophyte'), ('GAMETE', 'Gamete'), ('PUPA', 'Pupa'), ('UNDEFINED', 'Undefined')], default='UNDEFINED', max_length=11)),
                ('quantification', models.CharField(choices=[('COUNT', 'Count'), ('COVER', 'Cover'), ('PRESENCE', 'Presence')], default='PRESENCE', max_length=8)),
                ('creation_date', models.DateTimeField(auto_now_add=True)),
                ('last_update_date', models.DateTimeField(auto_now=True)),
                ('inventory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.inventory')),
                ('taxon', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.taxon')),
            ],
        ),
        migrations.AddField(
            model_name='inventory',
            name='inventory_list',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='inventories', to='core.inventorylist'),
        ),
        migrations.CreateModel(
            name='HistoricalVernacularEntry',
            fields=[
                ('id', models.IntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('name', models.TextField(db_index=True, validators=[django.core.validators.RegexValidator(message='Le nom vernaculaire ne peut contenir que des caractères français.', regex='^[a-zA-Z àâäèéêëîïôœùûüÿçÀÂÄÈÉÊËÎÏÔŒÙÛÜŸÇ"]*$')])),
                ('language', models.CharField(blank=True, choices=[('FR', 'Fr')], default='FR', max_length=2)),
                ('locality', models.CharField(blank=True, default='', max_length=100)),
                ('source', models.CharField(blank=True, default='', max_length=100)),
                ('score', models.IntegerField(blank=True, default=1)),
                ('gender', models.CharField(blank=True, choices=[('ALL', 'All'), ('FEMALE', 'Female'), ('MALE', 'Male'), ('UNDEFINED', 'Undefined')], default='ALL', max_length=10)),
                ('lifestage', models.CharField(blank=True, choices=[('ALL', 'All'), ('ZYGOTE', 'Zygote'), ('EMBRYO', 'Embryo'), ('LARVA', 'Larva'), ('JUVENILE', 'Juvenile'), ('ADULT', 'Adult'), ('SPOROPHYTE', 'Sporophyte'), ('SPORE', 'Spore'), ('GAMETOPHYTE', 'Gametophyte'), ('GAMETE', 'Gamete'), ('PUPA', 'Pupa'), ('UNDEFINED', 'Undefined')], default='ALL', max_length=11)),
                ('comment', models.CharField(blank=True, default='', max_length=150)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('taxon', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='core.taxon')),
            ],
            options={
                'verbose_name': 'historical vernacular entry',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='HistoricalUri',
            fields=[
                ('id', models.IntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('identifier', models.CharField(db_index=True, max_length=100, validators=[django.core.validators.RegexValidator(message='L"identifier doit être composés de lettres, chiffres ou -', regex='^[a-zA-Z-0-9]+$'), django.core.validators.RegexValidator(message="L'identifier ne peut pas contenir que des chiffres", regex='(?!^\\d+$)^.+$'), django.core.validators.MinLengthValidator(limit_value=3)])),
                ('creation_date', models.DateTimeField(blank=True, editable=False)),
                ('last_update_date', models.DateTimeField(blank=True, editable=False)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('inventory_list', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='core.inventorylist')),
            ],
            options={
                'verbose_name': 'historical uri',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='HistoricalTaxon',
            fields=[
                ('id', models.IntegerField(db_index=True)),
                ('rank', models.CharField(choices=[('ROOT', 'Root'), ('SUPERKINGDOM', 'Superkingdom'), ('KINGDOM', 'Kingdom'), ('SUBKINGDOM', 'Subkingdom'), ('SUPERPHYLUM', 'Superphylum'), ('PHYLUM', 'Phylum'), ('SUBPHYLUM', 'Subphylum'), ('SUPERCLASS', 'Superclass'), ('CLASS', 'Class'), ('SUBCLASS', 'Subclass'), ('INFRACLASS', 'Infraclass'), ('COHORT', 'Cohort'), ('SUBCOHORT', 'Subcohort'), ('SUPERORDER', 'Superorder'), ('ORDER', 'Order'), ('SUBORDER', 'Suborder'), ('INFRAORDER', 'Infraorder'), ('SUPERFAMILY', 'Superfamily'), ('FAMILY', 'Family'), ('SUBFAMILY', 'Subfamily'), ('TRIBE', 'Tribe'), ('SUBTRIBE', 'Subtribe'), ('GENUS', 'Genus'), ('SUBGENUS', 'Subgenus'), ('SECTION', 'Section'), ('SUBSECTION', 'Subsection'), ('SERIES', 'Series'), ('SPECIES', 'Species'), ('SUBSPECIES', 'Subspecies'), ('VARIETAS', 'Varietas'), ('SUBVARIETY', 'Subvariety'), ('FORMA', 'Forma'), ('FORMASPECIALIS', 'Formaspecialis'), ('CLADE', 'Clade'), ('STRAIN', 'Strain'), ('SEROGROUP', 'Serogroup'), ('SEROTYPE', 'Serotype'), ('BIOTYPE', 'Biotype'), ('GENOTYPE', 'Genotype'), ('SPECIESGROUP', 'Speciesgroup'), ('SPECIESSUBGROUP', 'Speciessubgroup'), ('ISOLATE', 'Isolate'), ('PARVORDER', 'Parvorder'), ('MORPH', 'Morph'), ('PATHOGROUP', 'Pathogroup'), ('UNDEFINED', 'Undefined')], default='UNDEFINED', max_length=21)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('main_scientific_entry', models.ForeignKey(blank=True, db_constraint=False, default=None, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='core.scientificentry')),
                ('parent', models.ForeignKey(blank=True, db_constraint=False, default=None, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='core.taxon')),
            ],
            options={
                'verbose_name': 'historical taxon',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='HistoricalScientificEntry',
            fields=[
                ('id', models.IntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('name', models.TextField(db_index=True)),
                ('source', models.CharField(blank=True, default='', max_length=100)),
                ('score', models.IntegerField(blank=True, default=1)),
                ('comment', models.CharField(blank=True, default='', max_length=150)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('taxon', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='core.taxon')),
            ],
            options={
                'verbose_name': 'historical scientific entry',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='HistoricalPlot',
            fields=[
                ('id', models.IntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('name', models.CharField(db_index=True, max_length=50)),
                ('description', models.TextField(blank=True, default='', max_length=250)),
                ('creation_date', models.DateTimeField(blank=True, editable=False)),
                ('last_update_date', models.DateTimeField(blank=True, editable=False)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('inventory', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='core.inventory')),
            ],
            options={
                'verbose_name': 'historical plot',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='HistoricalObservation',
            fields=[
                ('id', models.IntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('comment', models.TextField(blank=True, default='', max_length=250)),
                ('observator_nickname', models.CharField(blank=True, default='', max_length=30)),
                ('quantification_number', models.PositiveIntegerField(blank=True, null=True)),
                ('quantification_percentage', models.DecimalField(blank=True, decimal_places=3, max_digits=4, null=True, validators=[django.core.validators.MinValueValidator(0), django.core.validators.MaxValueValidator(1)])),
                ('alive', models.CharField(choices=[('YES', 'Yes'), ('NO', 'No'), ('UNDEFINED', 'Undefined')], default='UNDEFINED', max_length=9)),
                ('spontaneous', models.CharField(choices=[('YES', 'Yes'), ('NO', 'No'), ('UNDEFINED', 'Undefined')], default='UNDEFINED', max_length=9)),
                ('gender', models.CharField(choices=[('ALL', 'All'), ('FEMALE', 'Female'), ('MALE', 'Male'), ('UNDEFINED', 'Undefined')], default='UNDEFINED', max_length=9)),
                ('lifestage', models.CharField(choices=[('ALL', 'All'), ('ZYGOTE', 'Zygote'), ('EMBRYO', 'Embryo'), ('LARVA', 'Larva'), ('JUVENILE', 'Juvenile'), ('ADULT', 'Adult'), ('SPOROPHYTE', 'Sporophyte'), ('SPORE', 'Spore'), ('GAMETOPHYTE', 'Gametophyte'), ('GAMETE', 'Gamete'), ('PUPA', 'Pupa'), ('UNDEFINED', 'Undefined')], default='UNDEFINED', max_length=11)),
                ('quantification', models.CharField(choices=[('COUNT', 'Count'), ('COVER', 'Cover'), ('PRESENCE', 'Presence')], default='PRESENCE', max_length=8)),
                ('creation_date', models.DateTimeField(blank=True, editable=False)),
                ('last_update_date', models.DateTimeField(blank=True, editable=False)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('inventory', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='core.inventory')),
                ('taxon', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='core.taxon')),
            ],
            options={
                'verbose_name': 'historical observation',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='HistoricalInventoryList',
            fields=[
                ('id', models.IntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('name', models.CharField(db_index=True, max_length=50)),
                ('description', models.TextField(blank=True, default='', max_length=250)),
                ('status', models.CharField(choices=[('OPEN', 'Open'), ('CLOSED', 'Closed'), ('ARCHIVED', 'Archived')], default='OPEN', max_length=8)),
                ('creation_date', models.DateTimeField(blank=True, editable=False)),
                ('last_update_date', models.DateTimeField(blank=True, editable=False)),
                ('expiry_date', models.DateTimeField(blank=True, default=None, null=True)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'historical inventory list',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='HistoricalInventory',
            fields=[
                ('id', models.IntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('name', models.CharField(db_index=True, max_length=50)),
                ('status', models.CharField(choices=[('OPEN', 'Open'), ('CLOSED', 'Closed'), ('ARCHIVED', 'Archived')], default='OPEN', max_length=8)),
                ('description', models.TextField(blank=True, default='', max_length=250)),
                ('creation_date', models.DateTimeField(blank=True, editable=False)),
                ('last_update_date', models.DateTimeField(blank=True, editable=False)),
                ('expiry_date', models.DateTimeField(blank=True, null=True)),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('inventory_list', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='core.inventorylist')),
            ],
            options={
                'verbose_name': 'historical inventory',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.CreateModel(
            name='HistoricalIdentifiers',
            fields=[
                ('gbif', models.CharField(blank=True, default='', max_length=10, validators=[django.core.validators.RegexValidator(message="L'identifiant gbif doit être un nombre entier.", regex='^[0-9]*$')])),
                ('ncbi', models.CharField(blank=True, default='', max_length=10, validators=[django.core.validators.RegexValidator(message="L'identifiant ncbi doit être un nombre entier.", regex='^[0-9]*$')])),
                ('inaturalist', models.CharField(blank=True, default='', max_length=10, validators=[django.core.validators.RegexValidator(message="L'identifiant inaturalist doit être un nombre entier.", regex='^[0-9]*$')])),
                ('iucn', models.CharField(blank=True, default='', max_length=42, validators=[django.core.validators.RegexValidator(message="L'identifiant iucn doit être composé de deux nombres séparés par un '/'.", regex='^[0-9]+/[0-9]+$')])),
                ('wikidata', models.CharField(blank=True, default='', max_length=21, validators=[django.core.validators.RegexValidator(message="L'identifiant wikidata doit commencer par la lettre Q suivi d'un nombre.", regex='^Q[0-9]+$')])),
                ('wikispecies', models.CharField(blank=True, default='', max_length=50)),
                ('wikipedia', models.CharField(blank=True, default='', max_length=50)),
                ('taxref', models.CharField(blank=True, default='', max_length=10, validators=[django.core.validators.RegexValidator(message="L'identifiant taxref doit être un nombre entier.", regex='^[0-9]*$')])),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_change_reason', models.CharField(max_length=100, null=True)),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('taxon', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='core.taxon')),
            ],
            options={
                'verbose_name': 'historical identifiers',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
            bases=(simple_history.models.HistoricalChanges, models.Model),
        ),
        migrations.AddIndex(
            model_name='vernacularentry',
            index=django.contrib.postgres.indexes.GinIndex(django.contrib.postgres.indexes.OpClass(django.db.models.functions.text.Upper('name'), name='gin_trgm_ops'), name='core_v_name_trgm_gin_idx'),
        ),
        migrations.AddIndex(
            model_name='scientificentry',
            index=django.contrib.postgres.indexes.GinIndex(django.contrib.postgres.indexes.OpClass(django.db.models.functions.text.Upper('name'), name='gin_trgm_ops'), name='core_sc_name_trgm_gin_idx'),
        ),
    ]
